<?php 

require_once (WB_PATH.'/framework/functions.php');

class cleanup {


	public function __construct() {
		
	}
	
	public function find_tables_used() {
		global $database;
		$use = $this->known_list();
		$retval = array();
		$res = $database->query("SHOW TABLE STATUS");
		if($res) {
			while ($row = $res->fetchRow()) {
				$n = $row['Name'];
				if(isset($use[$n])) $retval[$n] = $use[$n];
			}
		}
		return $retval;
	}
	
	public function known_list() {
		global $admin;
		$r = array();
		$r[TABLE_PREFIX.'mod_form_submissions'] 	= array(1,'Form module','submitted_when');
		$r[TABLE_PREFIX.'mod_miniform_data'] 		= array(2,'Miniform','submitted_when');
		$r[TABLE_PREFIX.'mod_mpform_submissions'] 	= array(3,'MPform','submitted_when');
		$r[TABLE_PREFIX.'mod_job_resumes'] 			= array(4,'Jobs resumes','timestamp');
		$r[TABLE_PREFIX.'mod_news_comments'] 		= array(5,'News comments','commented_when');
		$r[TABLE_PREFIX.'mod_topics_comments'] 		= array(6,'Topics comments','commented_when');
		$r[TABLE_PREFIX.'mod_review_data'] 			= array(7,'Reviews module','timestamp');
		$r[TABLE_PREFIX.'mod_bakery_customer'] 		= array(8,'Bakery orders','order_date');
		//if( $admin->get_user_id() == 1 ) $r[TABLE_PREFIX.'users'] = array(9,'WB Login Users','login_when');
		return $r;
	}
	
	public function clean_extra ( $module = 0, $timestamp = 0, $table = '' ) {
		global $database, $cd;
		
		if($module  == 3) {  // MPform
			$sql = "SELECT `section_id` FROM `$table` WHERE `submitted_when` < '$timestamp' GROUP BY `section_id`";
			if($res = $database->query($sql)) {
				while ($row = $res->fetchRow()) {
					$sid = $row['section_id'];
					echo '<br>-- '.$cd['extrampform'].$sid;
				
					$tb = TABLE_PREFIX.'mod_mpform_results_'.$sid;
					$sql = "DELETE FROM `$tb` WHERE `submitted_when` < '$timestamp'";
					$database->query($sql);
					
					$tb = TABLE_PREFIX.'mod_mpform_settings';
					if($path = $database->get_one("SELECT `upload_files_folder` FROM `$tb` WHERE `section_id`='$sid'")) {
						$this->delete_files(WB_PATH.$path.'/',$timestamp);
					}
				}
			}
		}

		if($module  == 4) {  // Jobs
			echo '<br>-- '.$cd['extrajobs'];
			$this->delete_files(WB_PATH.'/modules/jobs/resumes/',$timestamp);
		}
		
	}
	
	private function delete_files($path, $timestamp) {
		if ($handle = opendir($path)) {  
			while (false !== ($file = readdir($handle))) {  
				if (is_file($path.$file)) {  
					$ftime = filemtime($path.$file);
					if ($ftime <  $timestamp) {  
						unlink($path.$file);  
					}  
				}  
			}  
		}  
	}
	
	public function count_messages($table,$field,$age = 'tomorrow') {
		global $database;
		if(!$table) return '';
		$timestamp = strtotime($age);
		$sql = "SELECT count(`$field`) FROM `$table` WHERE `$field` < '$timestamp'";
		$count = $database->get_one($sql);
		return $count;
	}
	
	public function clean($list) {
		global $database,$cd;	
		foreach ($list as $table => $values) {
			$lid = $values[0];
			if(isset($_POST['cleanit'][$lid])) {
				$p = @$_POST['period'][$lid];
				$field = $values[2];
				$timestamp = strtotime($p);
				$from = date(DATE_FORMAT,$timestamp);
				$sql = "DELETE FROM `$table` WHERE `$field` < '$timestamp'";
				echo '<div class="msg fine">'.$cd['cleaning'].' <strong>'.$values[1].'</strong> '.$cd['fromdate'].' <strong>'.$from.'</strong>';
				$this->clean_extra($lid,$timestamp,$table);
				$database->query($sql);
				echo '</div>';
			}
		}
	}
	
	public function get_select($id = 0,$table = '',$field = '') {
		global $cd;
		$rval = '
			<select class="period" id="'.$id.'" name="'.$id.'">
				<option value="-1 year">'.$cd['oneyear'].' ('.$this->count_messages($table,$field,'-1 year').')</option>
				<option value="-6 months">'.$cd['sixmonths'].' ('.$this->count_messages($table,$field,'-6 months').')</option>
				<option value="-3 months">'.$cd['threemonths'].' ('.$this->count_messages($table,$field,'-3 months').')</option>
				<option value="-1 month">'.$cd['onemonth'].' ('.$this->count_messages($table,$field,'-1 month').')</option>
				<option value="-2 weeks">'.$cd['twoweeks'].' ('.$this->count_messages($table,$field,'-2 weeks').')</option>
				<option value="-1 week">'.$cd['oneweek'].' ('.$this->count_messages($table,$field,'-1 week').')</option>
				<option value="-1 day">'.$cd['oneday'].' ('.$this->count_messages($table,$field,'-1 day').')</option>
				<option value="now">'.$cd['today'].' ('.$this->count_messages($table,$field,'now').')</option>
			</select>';
			return $rval;
	}
	
}