<?php
/**
 *
 * @category        admintool
 * @package         Cleandata
 * @author          Ruud Eisinga - www.dev4me.nl
 * @link			http://www.dev4me.nl/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @version         1.0.0
 * @lastmodified    May 18, 2018
 *
 */
 
if(defined('WB_PATH') == false) { die("Cannot access this file directly"); }
require dirname(__FILE__).'/cleandata.class.php';


$modPath = str_replace('\\', '/', dirname(__FILE__)).'/';
if(!is_readable($modPath.'languages/'.LANGUAGE .'.php')) {
	require_once($modPath.'languages/EN.php');
} else {
	require_once($modPath.'languages/'.LANGUAGE .'.php');
}
$key = md5(session_id());

$c = new cleanup();
$list = $c->find_tables_used();
if(isset($_POST['key']) && $_POST['key'] ==  $key) {
	$c->clean($list);
}

?>
<h2><?php echo $cd['title'] ?> <span>- by dev4me</span></h2>
<?php if (count($list) == 0) { ?>
<div class="msg fine"><strong><?php echo $cd['norec'] ?></strong></div>
<?php return; } ?>

<?php if(!isset($_POST['key'])) { ?>
<div class="msg warning"><strong><?php echo $cd['warning'] ?></strong></div>
<?php } ?>

<hr/>
<form id="doForm" name="do" method="post" action="<?php echo ADMIN_URL ?>/admintools/tool.php?tool=cleandata">
	<input type="hidden" name="key" value="<?php echo $key ?>" />
	<table class="clean">
		<tr>
			<th><?php echo $cd['module'] ?></td>
			<th class="count"><?php echo $cd['totalrec'] ?></td>
			<th class="check"><?php echo $cd['clean'] ?><br><input class="check_all" type="checkbox" name="cleanall" value="x" /></td>
			<th class="check"><?php echo $cd['age'] ?><br><?php echo $c->get_select('all_period'); ?></td>
		</tr>		
		<?php  foreach ( $list as $table => $field) { ?>
		<tr>
			<td class="name"><?php echo $field[1] ?></td>
			<td class="count"><?php echo $c->count_messages($table,$field[2]) ?></td>
			<td class="check"><input class="check_cb" type="checkbox" name="cleanit[<?php echo $field[0] ?>]" value="<?php echo $field[0] ?>" /></td>
			<td class="check"><?php echo $c->get_select('period['.$field[0].']',$table,$field[2]); ?></td>
		</tr>
		<?php } ?>
		<tr>
			<td colspan='4' class="name"><input disabled onclick="return cleanConfirm();" type="submit" id="btn-submit" name="submit" value="<?php echo $cd['submit'] ?>" /></td>
		</tr>
	</table>
</form>
<script>
function cleanConfirm() {
    if (confirm("<?php echo $cd['sure'] ?>")) {
        return true;
    } else {
        return false;
    }
}
</script>